## gccxml 0.9.0+git20140716

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.3 FATAL_ERROR)
PROJECT(gccxml)

# We are not using shared libraries.  Skip any RPATH.
SET(CMAKE_SKIP_RPATH 1)

# Tell GCC_XML that we are providing gccxml_cc1plus for it.
SET(GCCXML_NATIVE_CC1PLUS 1)

# Place both gccxml_cc1plus and the GCC_XML executables next to each
# other.
SET(EXECUTABLE_OUTPUT_PATH "${gccxml_BINARY_DIR}/bin" CACHE PATH
  "Single output directory for all executables.")
MARK_AS_ADVANCED(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)

# Tell GCC and GCC-XML where to install relative to the CMAKE_INSTALL_PREFIX.
SET(GCCXML_INSTALL_ROOT)

# Installation component names for stand-alone GCC-XML.
SET(GCCXML_INSTALL_COMPONENT_NAME_DOCUMENTATION Documentation)
SET(GCCXML_INSTALL_COMPONENT_NAME_RUNTIME_EXECUTABLE RuntimeExecutable)
SET(GCCXML_INSTALL_COMPONENT_NAME_RUNTIME_LIBRARY RuntimeLibrary)

# Dashboard support
INCLUDE(CTest)

# Test GCC_XML.
ENABLE_TESTING()
SET(GCCXML_ADD_TESTS 1)

# Build GCC and GCC_XML.
ADD_SUBDIRECTORY(GCC)
ADD_SUBDIRECTORY(GCC_XML)

# Use CPack to build a redistributable installer
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/gccxmlCPack.cmake")

=== GCC/libdecnumber/CMakeLists.txt ===
INCLUDE_DIRECTORIES(BEFORE
  ${GCC_SOURCE_DIR}/include
  ${GCC_SOURCE_DIR}/libdecnumber/include
  ${GCC_BINARY_DIR}/libdecnumber
  )
SET(decnumber_SRCS
  decNumber.c decContext.c decUtility.c decimal32.c decimal64.c
  decimal128.c
  )
ADD_LIBRARY(decnumber ${decnumber_SRCS})
#TARGET_LINK_LIBRARIES(decnumber iberty)

=== GCC_XML/GXFront/CMakeLists.txt ===
# The GCC-XML forwarding exectuable.
ADD_EXECUTABLE(gccxml
  gxSystemTools.cxx
  gxConfiguration.cxx
  gxDocumentation.cxx
  gxFlagsParser.cxx
  gxFront.cxx
)

TARGET_LINK_LIBRARIES(gccxml gxsys)

IF(TARGET vcInstallPatch)
  ADD_DEPENDENCIES(gccxml vcInstallPatch)
ENDIF()

# If we are inside a project that is building gccxml_cc1plus for us,
# add the dependency to build it first.
IF(GCCXML_NATIVE_CC1PLUS)
  ADD_DEPENDENCIES(gccxml gccxml_cc1plus)
ENDIF(GCCXML_NATIVE_CC1PLUS)

#-----------------------------------------------------------------------------
# Generate documentation.
MAKE_DIRECTORY(${GCCXML_BINARY_DIR}/doc)

ADD_CUSTOM_TARGET(documentation ALL DEPENDS
  ${GCCXML_BINARY_DIR}/doc/gccxml.1
  ${GCCXML_BINARY_DIR}/doc/gccxml.txt
  ${GCCXML_BINARY_DIR}/doc/gccxml.html
  ${GCCXML_BINARY_DIR}/doc/Copyright.txt)
ADD_DEPENDENCIES(documentation gccxml)

ADD_CUSTOM_COMMAND(OUTPUT ${GCCXML_BINARY_DIR}/doc/gccxml.1
  COMMAND gccxml --man > ${GCCXML_BINARY_DIR}/doc/gccxml.1
  DEPENDS gccxml
  )

ADD_CUSTOM_COMMAND(OUTPUT ${GCCXML_BINARY_DIR}/doc/gccxml.txt
  COMMAND gccxml --help > ${GCCXML_BINARY_DIR}/doc/gccxml.txt
  DEPENDS gccxml
  )

ADD_CUSTOM_COMMAND(OUTPUT ${GCCXML_BINARY_DIR}/doc/gccxml.html
  COMMAND gccxml --help-html > ${GCCXML_BINARY_DIR}/doc/gccxml.html
  DEPENDS gccxml
  )

ADD_CUSTOM_COMMAND(OUTPUT ${GCCXML_BINARY_DIR}/doc/Copyright.txt
  COMMAND gccxml --copyright > ${GCCXML_BINARY_DIR}/doc/Copyright.txt
  DEPENDS gccxml
  )

INSTALL(TARGETS gccxml
  RUNTIME DESTINATION ${GCCXML_INSTALL_ROOT}bin
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_EXECUTABLE})
INSTALL(FILES ${GCCXML_BINARY_DIR}/doc/gccxml.1
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_MAN_DIR}/man1
  ${GCCXML_INSTALL_COMPONENT_DOCUMENTATION})
INSTALL(FILES
  ${GCCXML_BINARY_DIR}/doc/gccxml.txt
  ${GCCXML_BINARY_DIR}/doc/gccxml.html
  ${GCCXML_BINARY_DIR}/doc/Copyright.txt
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DOC_DIR}
  ${GCCXML_INSTALL_COMPONENT_DOCUMENTATION})

=== GCC_XML/Support/CMakeLists.txt ===
# Install UNIX compiler support files.
INSTALL(FILES gccxml_identify_compiler.cc
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DATA_DIR}
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY})

INSTALL(
  DIRECTORY GCC Intel MIPSpro Sun IBM
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DATA_DIR}
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY}
  PATTERN "find_flags"
    PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
                OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
  PATTERN "*.sh"
    PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
                OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
  PATTERN "CVS" EXCLUDE
  PATTERN "CMakeLists.txt" EXCLUDE
  PATTERN ".#*" EXCLUDE
  )

IF(WIN32)
  # Install Windows compiler support files.
  INSTALL(
    DIRECTORY Borland
    DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DATA_DIR}
    ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY}
    PATTERN "CVS" EXCLUDE
    PATTERN "CMakeLists.txt" EXCLUDE
    PATTERN ".#*" EXCLUDE
    )
ENDIF(WIN32)

=== GCC_XML/Testing/CMakeLists.txt ===
SET(EXE_DIR ".")
IF(EXECUTABLE_OUTPUT_PATH)
  SET(EXE_DIR "${EXECUTABLE_OUTPUT_PATH}")
ENDIF(EXECUTABLE_OUTPUT_PATH)

INCLUDE_DIRECTORIES(
  "${GCCXML_BINARY_DIR}/GXFront"
  "${GCCXML_SOURCE_DIR}/GXFront"
)

SET(gccxml_dashI_args "")
GET_DIRECTORY_PROPERTY(GX_INCS INCLUDE_DIRECTORIES)
FOREACH(inc ${GX_INCS})
  SET(gccxml_dashI_args ${gccxml_dashI_args} "-I${inc}")
ENDFOREACH(inc)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/TestFullPathInclude.cxx.in"
  "${CMAKE_CURRENT_BINARY_DIR}/TestFullPathInclude.cxx"
  @ONLY
)

SET(GX_TESTS
  "${GCCXML_SOURCE_DIR}/GXFront/gxConfiguration.cxx"
  "${GCCXML_SOURCE_DIR}/GXFront/gxConfiguration.h"
  "${GCCXML_SOURCE_DIR}/GXFront/gxDocumentation.cxx"
  "${GCCXML_SOURCE_DIR}/GXFront/gxDocumentation.h"
  "${GCCXML_SOURCE_DIR}/GXFront/gxFlagsParser.cxx"
  "${GCCXML_SOURCE_DIR}/GXFront/gxFlagsParser.h"
  "${GCCXML_SOURCE_DIR}/GXFront/gxFront.cxx"
  "${GCCXML_SOURCE_DIR}/GXFront/gxSystemTools.cxx"
  "${GCCXML_SOURCE_DIR}/GXFront/gxSystemTools.h"
  "${CMAKE_CURRENT_BINARY_DIR}/TestFullPathInclude.cxx"
  "${CMAKE_CURRENT_SOURCE_DIR}/TestUsualInclude.cxx"
)

FOREACH(test ${GX_TESTS})
  GET_FILENAME_COMPONENT(name "${test}" NAME)
  GET_FILENAME_COMPONENT(name_we "${test}" NAME_WE)
  ADD_TEST(${name}
    ${EXE_DIR}/gccxml ${gccxml_dashI_args} ${test} -fxml=${name}.gcc.xml
  )
ENDFOREACH(test)

=== GCC_XML/VcInstall/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${GCCXML_SOURCE_DIR}/GXFront)

# Create an executable to detect VS installations and copy and patch
# the headers.
SET(VCCONFIG_TARGET "gccxml_vcconfig")
ADD_EXECUTABLE(${VCCONFIG_TARGET} vcInstall.cxx
  ${GCCXML_SOURCE_DIR}/GXFront/gxSystemTools.cxx)
TARGET_LINK_LIBRARIES(${VCCONFIG_TARGET} gxsys)

# Install the ${VCCONFIG_TARGET} executable.
INSTALL(TARGETS ${VCCONFIG_TARGET}
  RUNTIME DESTINATION ${GCCXML_INSTALL_ROOT}bin
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY})

# Create the MSVC support directories.
# This will just execute on every build because we don't know
# what files and directories it may create.
ADD_CUSTOM_COMMAND(
  OUTPUT ${GCCXML_BINARY_DIR}/vcInstall_stamp.c

  COMMAND ${VCCONFIG_TARGET}
  ${GCCXML_SOURCE_DIR}/VcInstall ${GCCXML_BINARY_DIR}/Support
  ${GCCXML_BINARY_DIR}/vcInstall_stamp.c

  DEPENDS ${VCCONFIG_TARGET}
  ${GCCXML_SOURCE_DIR}/VcInstall/vc6Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc7Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc7PlatformSDK.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc71Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc71PlatformSDK.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8PlatformSDK.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8sp1Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8sp1PlatformSDK.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8ExpressInclude.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8ExpressPlatformSDK.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc8sp1ExpressInclude.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc9Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc9PlatformSDK.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc9sp1Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc10Include.patch
  ${GCCXML_SOURCE_DIR}/VcInstall/vc10PlatformSDK.patch
  )
ADD_CUSTOM_TARGET(vcInstallPatch DEPENDS
  ${GCCXML_BINARY_DIR}/vcInstall_stamp.c)

# Create a script to run the ${VCCONFIG_TARGET} executable in an
# already-installed GCC-XML tree.
STRING(REGEX REPLACE "/" "\\\\" VC_DATA_DIR "${GCCXML_DATA_DIR}")
CONFIGURE_FILE(${GCCXML_SOURCE_DIR}/VcInstall/gccxml_vcupdate.bat.in
  ${GCCXML_BINARY_DIR}/VcInstall/${VCCONFIG_TARGET}.bat
  @ONLY IMMEDIATE)

# Install the patch files.
FILE(GLOB VCPATCH_FILES "vc*.patch")
INSTALL(
  FILES ${VCPATCH_FILES}
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DATA_DIR}/VcInstall
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY})

# Install the update script helper files.
INSTALL(
  FILES
    ${GCCXML_SOURCE_DIR}/VcInstall/vcCat.readme.txt
    ${GCCXML_SOURCE_DIR}/VcInstall/vcPatch.readme.txt
    ${GCCXML_SOURCE_DIR}/VcInstall/vc_helper
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DATA_DIR}/VcInstall
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY})
INSTALL(
  PROGRAMS ${GCCXML_SOURCE_DIR}/VcInstall/vcCat.exe
           ${GCCXML_SOURCE_DIR}/VcInstall/vcPatch.exe
  DESTINATION ${GCCXML_INSTALL_ROOT}${GCCXML_DATA_DIR}/VcInstall
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_LIBRARY})

# Install the update script.
INSTALL(
  PROGRAMS ${GCCXML_BINARY_DIR}/VcInstall/${VCCONFIG_TARGET}.bat
  DESTINATION ${GCCXML_INSTALL_ROOT}bin
  ${GCCXML_INSTALL_COMPONENT_RUNTIME_EXECUTABLE})

# Run the update script during installation.
#IF(NOT GCCXML_NO_VCINSTALL_UPDATE)
#  INSTALL(CODE "
#EXECUTE_PROCESS(COMMAND \"$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/${GCCXML_INSTALL_ROOT}bin/gccxml_vcupdate.bat\")
#")
#ENDIF(NOT GCCXML_NO_VCINSTALL_UPDATE)

=== debian/control ===
Source: gccxml
Section: devel
Priority: optional
Maintainer: Steve M. Robbins <smr@debian.org>
Build-Depends: debhelper (>= 9), cmake, autotools-dev, gcc-4.9, g++-4.9
Build-Conflicts: ccache
Homepage: http://www.gccxml.org/
Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/gccxml/trunk/
Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/gccxml/trunk
Standards-Version: 3.9.5

Package: gccxml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: XML output extension to GCC
 There is one open-source C++ parser, the C++ front-end to GCC, which
 is currently able to deal with the language in its entirety. The
 purpose of the GCC-XML extension is to generate an XML description of
 a C++ program from GCC's internal representation. Since XML is easy to
 parse, other development tools will be able to work with C++ programs
 without the burden of a complicated C++ parser.

Package: libgccxml-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Libraries for building extension to gccxml output
 There is one open-source C++ parser, the C++ front-end to GCC, which
 is currently able to deal with the language in its entirety. The
 purpose of the GCC-XML extension is to generate an XML description of
 a C++ program from GCC's internal representation. Since XML is easy to
 parse, other development tools will be able to work with C++ programs
 without the burden of a complicated C++ parser.
 .
 These libraries are part of the GCC-XML tool.

=== debian/rules ===
#!/usr/bin/make -f


export CC=gcc-4.9
export CXX=g++-4.9

CMAKE_FLAGS = -DGCCXML_INSTALL_FOR_MUMMY:BOOL=ON \
	-DGCCXML_DOC_DIR:STRING=/share/doc/gccxml

pkg_run = gccxml
pkg_dev = libgccxml-dev

%:
	dh $@ --buildsystem=cmake --parallel --with=autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_install:
	# Runtime Package
	dh_install -p$(pkg_run) usr/bin
	dh_install -p$(pkg_run) usr/share
	# Development Package
	dh_install -p$(pkg_dev) usr/include
	dh_install -p$(pkg_dev) --autodest usr/lib/lib*.a

override_dh_auto_build:
	cp -a debian/Support/* GCC_XML/Support
	dh_auto_build

get-orig-source:
	./debian/makeSource.sh
